/*
  XVarStar, GCVS catalogue explorer
  Copyright (C) 2001-2008 Ivan Vitjuk 

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include <malloc.h>
#include <string.h>

#include "variable.h"

variable_t *var_list_init(void)
{
        variable_t *tmp;
        
        if((tmp = (variable_t *)malloc(sizeof(variable_t))))
                memset(tmp, 0, sizeof(variable_t));
        return tmp;
}

void var_list_free(variable_t *varlist)
{
        if(varlist && varlist->head){
                struct variable *tmp;
                while(varlist->head){
                        tmp = varlist->head->next;
                        free(varlist->head);
                        varlist->head = tmp;
                }
                free(varlist);
        }
}

void var_list_insert(variable_t *varlist, struct variable *var)
{
        if(!varlist)
                return;
        
        if(!varlist->head){
                if((varlist->head  = (struct variable *)malloc(sizeof(*var)))){
                        varlist->tail = varlist->head;
                        *(varlist->head) = *var;
                        varlist->head->next = NULL;
                        varlist->count = 1;
                }
        }else{
                if(varlist->tail->next = (struct variable *)malloc(sizeof(*var))){
                        *(varlist->tail->next) = *var;
                        varlist->tail = varlist->tail->next;
                        varlist->tail->next = NULL;
                        varlist->count++;
                }
        }
}

void var_list_print(variable_t *varlist)
{
        struct variable *tmp;
        
        var_print_header(stdout);
        if(varlist)
                for(tmp = varlist->head; tmp; tmp=tmp->next)
                        var_print_object(tmp, stdout);
}
